# Class MetalToggleButtonUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.ButtonUI
javax.swing.plaf.basic.BasicButtonUI
javax.swing.plaf.basic.BasicToggleButtonUI
javax.swing.plaf.metal.MetalToggleButtonUI

public class MetalToggleButtonUI extends BasicToggleButtonUI
MetalToggleButton implementation

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected Color`
`disabledTextColor`
The color of a disabled text.
`protected Color`
`focusColor`
The color of a focused toggle button.
`protected Color`
`selectColor`
The color of a selected button.

### Fields declared in class BasicButtonUI

`defaultTextIconGap, defaultTextShiftOffset`
Modifier and Type
Field
Description
`protected int`
`defaultTextIconGap`
The default gap between a text and an icon.
`protected int`
`defaultTextShiftOffset`
The default offset of a text.

## Constructor Summary

Constructors
Constructor
Description
`MetalToggleButtonUI()`
Constructs a `MetalToggleButtonUI`.

## Method Summary

Modifier and Type
Method
Description
`static ComponentUI`
`createUI(JComponent b)`
Constructs the `MetalToggleButtonUI`.
`protected Color`
`getDisabledTextColor()`
Returns the color of a disabled text.
`protected Color`
`getFocusColor()`
Returns the color of a focused toggle button.
`protected Color`
`getSelectColor()`
Returns the color of a selected button.
`void`
`installDefaults(AbstractButton b)`
Installs default properties.
`protected void`
`paintIcon(Graphics g, AbstractButton b, Rectangle iconRect)`
Paints the appropriate icon of the button `b` in the space `iconRect`.
`void`
`update(Graphics g, JComponent c)`
If necessary paints the background of the component, then invokes `paint`.

### Methods declared in class BasicToggleButtonUI

`getTextShiftOffset`
Modifier and Type
Method
Description
`protected int`
`getTextShiftOffset()`
Overridden so that the text will not be rendered as shifted for Toggle buttons and subclasses.

### Methods declared in class BasicButtonUI

`clearTextShiftOffset, createButtonListener, getBaseline, getBaselineResizeBehavior, getDefaultTextIconGap, getPropertyPrefix, installKeyboardActions, installListeners, paintButtonPressed, paintFocus, paintIcon, paintText, paintText, setTextShiftOffset, uninstallDefaults, uninstallKeyboardActions, uninstallListeners`
Modifier and Type
Method
Description
`protected void`
`clearTextShiftOffset()`
Clears the offset of the text.
`protected BasicButtonListener`
`createButtonListener(AbstractButton b)`
Returns a new instance of `BasicButtonListener`.
`int`
`getBaseline(JComponent c, int width, int height)`
Returns the baseline.
`Component.BaselineResizeBehavior`
`getBaselineResizeBehavior(JComponent c)`
Returns an enum indicating how the baseline of the component changes as the size changes.
`int`
`getDefaultTextIconGap(AbstractButton b)`
Returns the default gap between a text and an icon.
`protected String`
`getPropertyPrefix()`
Returns the property prefix.
`protected void`
`installKeyboardActions(AbstractButton b)`
Registers keyboard actions.
`protected void`
`installListeners(AbstractButton b)`
Registers listeners.
`protected void`
`paintButtonPressed(Graphics g, AbstractButton b)`
Paints a pressed button.
`protected void`
`paintFocus(Graphics g, AbstractButton b, Rectangle viewRect, Rectangle textRect, Rectangle iconRect)`
Paints a focused button.
`protected void`
`paintIcon(Graphics g, JComponent c, Rectangle iconRect)`
Paints an icon of the current button.
`protected void`
`paintText(Graphics g, AbstractButton b, Rectangle textRect, String text)`
Method which renders the text of the current button.
`protected void`
`paintText(Graphics g, JComponent c, Rectangle textRect, String text)`
Method which renders the text of the current button.
`protected void`
`setTextShiftOffset()`
Sets the offset of the text.
`protected void`
`uninstallDefaults(AbstractButton b)`
Uninstalls default properties.
`protected void`
`uninstallKeyboardActions(AbstractButton b)`
Unregisters keyboard actions.
`protected void`
`uninstallListeners(AbstractButton b)`
Unregisters listeners.

### Methods declared in class ComponentUI

`contains, getAccessibleChild, getAccessibleChildrenCount, getMaximumSize, getMinimumSize, getPreferredSize, installUI, paint, uninstallUI`
Modifier and Type
Method
Description
`boolean`
`contains(JComponent c, int x, int y)`
Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
`Accessible`
`getAccessibleChild(JComponent c, int i)`
Returns the `i`th `Accessible` child of the object.
`int`
`getAccessibleChildrenCount(JComponent c)`
Returns the number of accessible children in the object.
`Dimension`
`getMaximumSize(JComponent c)`
Returns the specified component's maximum size appropriate for the look and feel.
`Dimension`
`getMinimumSize(JComponent c)`
Returns the specified component's minimum size appropriate for the look and feel.
`Dimension`
`getPreferredSize(JComponent c)`
Returns the specified component's preferred size appropriate for the look and feel.
`void`
`installUI(JComponent c)`
Configures the specified component appropriately for the look and feel.
`void`
`paint(Graphics g, JComponent c)`
Paints the specified component appropriately for the look and feel.
`void`
`uninstallUI(JComponent c)`
Reverses configuration which was done on the specified component during `installUI`.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### focusColor

protected Color focusColor
The color of a focused toggle button.

### selectColor

protected Color selectColor
The color of a selected button.

### disabledTextColor

protected Color disabledTextColor
The color of a disabled text.

## Constructor Details

### MetalToggleButtonUI

public MetalToggleButtonUI()
Constructs a `MetalToggleButtonUI`.

## Method Details

### createUI

public static ComponentUI createUI(JComponent b)
Constructs the `MetalToggleButtonUI`.

Parameters:
  `b` - a component
Returns:
  the `MetalToggleButtonUI`.

### installDefaults

public void installDefaults(AbstractButton b)
Description copied from class: `BasicButtonUI`
Installs default properties.

Overrides:
  `installDefaults` in class `BasicButtonUI`
Parameters:
  `b` - an abstract button

### getSelectColor

protected Color getSelectColor()
Returns the color of a selected button.

Returns:
  the color of a selected button

### getDisabledTextColor

protected Color getDisabledTextColor()
Returns the color of a disabled text.

Returns:
  the color of a disabled text

### getFocusColor

protected Color getFocusColor()
Returns the color of a focused toggle button.

Returns:
  the color of a focused toggle button

### update

public void update(Graphics g, JComponent c)
If necessary paints the background of the component, then invokes `paint`.

Overrides:
  `update` in class `ComponentUI`
Parameters:
  `g` - Graphics to paint to
  `c` - JComponent painting on
Throws:
  `NullPointerException` - if `g` or `c` is null
Since:
  1.5
See Also:
  - `ComponentUI.update(Graphics, JComponent)`
  - `ComponentUI.paint(Graphics, JComponent)`

### paintIcon

protected void paintIcon(Graphics g, AbstractButton b, Rectangle iconRect)
Paints the appropriate icon of the button `b` in the space `iconRect`.

Overrides:
  `paintIcon` in class `BasicToggleButtonUI`
Parameters:
  `g` - Graphics to paint to
  `b` - Button to render for
  `iconRect` - space to render in
Throws:
  `NullPointerException` - if any of the arguments are null.
Since:
  1.5